<?php
//Try to load the extension if it's not already loaded.
if(!extension_loaded('zorba_api')) {
  if(strtolower(substr(PHP_OS, 0, 3)) === 'win') {
    if(!dl('php_zorba_api.dll')) return;
  } else {
    if(PHP_SHLIB_SUFFIX === 'PHP_SHLIB_SUFFIX' || PHP_SHLIB_SUFFIX === 'dylib') {
      if(!dl('zorba_api.so')) return;
    } else {
      if(!dl('zorba_api.' . PHP_SHLIB_SUFFIX)) return;
    }
  }
}
class DynamicContext{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  DynamicContext___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  DynamicContext___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  DynamicContext___get($this->_cPtr, $var);
    return $r;

  }

  public function setVariable($aNamespace, $aLocalname, $arg3) {
    $r =  DynamicContext_setVariable($this->_cPtr, $aNamespace, $aLocalname, $arg3);
    return $r;

  }

  public function setContextItem($arg1) {
    $r =  DynamicContext_setContextItem($this->_cPtr, $arg1);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class Item{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  Item___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  Item___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  Item___get($this->_cPtr, $var);
    return $r;

  }

  static  public function createEmptyItem() {
    $r =  Item_createEmptyItem();
    return is_resource($r) ? new Item($r) : $r;

  }

  public function getStringValue() {
    $r =  Item_getStringValue($this->_cPtr);
    return $r;

  }

  public function serialize() {
    $r =  Item_serialize($this->_cPtr);
    return $r;

  }

  public function getAtomizationValue() {
    $r =  Item_getAtomizationValue($this->_cPtr);
    return is_resource($r) ? new IteratorImpl($r) : $r;

  }

  public function getAttributes() {
    $r =  Item_getAttributes($this->_cPtr);
    return is_resource($r) ? new IteratorImpl($r) : $r;

  }

  public function getBooleanValue() {
    $r =  Item_getBooleanValue($this->_cPtr);
    return $r;

  }

  public function getChildren() {
    $r =  Item_getChildren($this->_cPtr);
    return is_resource($r) ? new IteratorImpl($r) : $r;

  }

  public function getEBV() {
    $r =  Item_getEBV($this->_cPtr);
    return is_resource($r) ? new Item($r) : $r;

  }

  public function getIntValue() {
    $r =  Item_getIntValue($this->_cPtr);
    return $r;

  }

  public function getLocalName() {
    $r =  Item_getLocalName($this->_cPtr);
    return $r;

  }

  public function getNamespace() {
    $r =  Item_getNamespace($this->_cPtr);
    return $r;

  }

  public function getNodeName($aNodeName) {
    $r =  Item_getNodeName($this->_cPtr, $aNodeName);
    return $r;

  }

  public function getPrefix() {
    $r =  Item_getPrefix($this->_cPtr);
    return $r;

  }

  public function getType() {
    $r =  Item_getType($this->_cPtr);
    return is_resource($r) ? new Item($r) : $r;

  }

  public function getUnsignedIntValue() {
    $r =  Item_getUnsignedIntValue($this->_cPtr);
    return $r;

  }

  public function getNodeKind() {
    $r =  Item_getNodeKind($this->_cPtr);
    return $r;

  }

  public function isAtomic() {
    $r =  Item_isAtomic($this->_cPtr);
    return $r;

  }

  public function isNaN() {
    $r =  Item_isNaN($this->_cPtr);
    return $r;

  }

  public function isNode() {
    $r =  Item_isNode($this->_cPtr);
    return $r;

  }

  public function isNull() {
    $r =  Item_isNull($this->_cPtr);
    return $r;

  }

  public function isPosOrNegInf() {
    $r =  Item_isPosOrNegInf($this->_cPtr);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class IteratorImpl{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  Iterator___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  Iterator___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  Iterator___get($this->_cPtr, $var);
    return $r;

  }

  public function open() {
    $r =  Iterator_open($this->_cPtr);
    return $r;

  }

  public function next($arg1) {
    $r =  Iterator_next($this->_cPtr, $arg1);
    return $r;

  }

  public function close() {
    $r =  Iterator_close($this->_cPtr);
    return $r;

  }

  public function destroy() {
    $r =  Iterator_destroy($this->_cPtr);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class XQuery{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  XQuery___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  XQuery___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  XQuery___get($this->_cPtr, $var);
    return $r;

  }

  public function execute() {
    $r =  XQuery_execute($this->_cPtr);
    return $r;

  }

  public function printPlanAsXML() {
    $r =  XQuery_printPlanAsXML($this->_cPtr);
    return $r;

  }

  public function printPlanAsDOT() {
    $r =  XQuery_printPlanAsDOT($this->_cPtr);
    return $r;

  }

  public function destroy() {
    $r =  XQuery_destroy($this->_cPtr);
    return $r;

  }

  public function iterator() {
    $r =  XQuery_iterator($this->_cPtr);
    return is_resource($r) ? new IteratorImpl($r) : $r;

  }

  public function getDynamicContext() {
    $r =  XQuery_getDynamicContext($this->_cPtr);
    return is_resource($r) ? new DynamicContext($r) : $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class Store{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  Store___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  Store___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  Store___get($this->_cPtr, $var);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class InMemoryStore extends Store{
  public $_cPtr=null;

  static  public function getInstance() {
    $r =  InMemoryStore_getInstance();
    return is_resource($r) ? new InMemoryStore($r) : $r;

  }

  static  public function shutdown($arg1) {
    $r =  InMemoryStore_shutdown($arg1);
    return $r;

  }

}

class DocumentManager{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  DocumentManager___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  DocumentManager___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  DocumentManager___get($this->_cPtr, $var);
    return $r;

  }

  public function put($aName, $aDoc) {
    $r =  DocumentManager_put($this->_cPtr, $aName, $aDoc);
    return $r;

  }

  public function remove($aName) {
    $r =  DocumentManager_remove($this->_cPtr, $aName);
    return $r;

  }

  public function document($aName) {
    $r =  DocumentManager_document($this->_cPtr, $aName);
    return is_resource($r) ? new Item($r) : $r;

  }

  public function isAvailableDocument($aName) {
    $r =  DocumentManager_isAvailableDocument($this->_cPtr, $aName);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class XmlDataManager{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  XmlDataManager___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  XmlDataManager___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  XmlDataManager___get($this->_cPtr, $var);
    return $r;

  }

  public function getDocumentManager() {
    $r =  XmlDataManager_getDocumentManager($this->_cPtr);
    return is_resource($r) ? new DocumentManager($r) : $r;

  }

  public function parseXML($aDoc) {
    $r =  XmlDataManager_parseXML($this->_cPtr, $aDoc);
    return is_resource($r) ? new IteratorImpl($r) : $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class ZorbaException{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  ZorbaException___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  ZorbaException___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  ZorbaException___get($this->_cPtr, $var);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

  public function getDescription() {
    $r =  ZorbaException_getDescription($this->_cPtr);
    return $r;

  }

  public function getErrorCode() {
    $r =  ZorbaException_getErrorCode($this->_cPtr);
    return $r;

  }

  public function getFileLineNumber() {
    $r =  ZorbaException_getFileLineNumber($this->_cPtr);
    return $r;

  }

  public function getFileName() {
    $r =  ZorbaException_getFileName($this->_cPtr);
    return $r;

  }

  static  public function getErrorCodeAsString($aErrorCode) {
    $r =  ZorbaException_getErrorCodeAsString($aErrorCode);
    return $r;

  }

}

class XQueryException extends ZorbaException{
  public $_cPtr=null;

  public function getColumnBegin() {
    $r =  XQueryException_getColumnBegin($this->_cPtr);
    return $r;

  }

  public function getLineBegin() {
    $r =  XQueryException_getLineBegin($this->_cPtr);
    return $r;

  }

  public function getQueryURI() {
    $r =  XQueryException_getQueryURI($this->_cPtr);
    return $r;

  }

}

class CompilerHints{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  CompilerHints___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  CompilerHints___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  CompilerHints___get($this->_cPtr, $var);
    return $r;

  }

  public function getLibModule() {
    $r =  CompilerHints_getLibModule($this->_cPtr);
    return $r;

  }

  public function setLibModule($aLibModule) {
    $r =  CompilerHints_setLibModule($this->_cPtr, $aLibModule);
    return $r;

  }

  public function getOptimizationLevel() {
    $r =  CompilerHints_getOptimizationLevel($this->_cPtr);
    return $r;

  }

  public function setOptimizationLevel($aOptLevel) {
    $r =  CompilerHints_setOptimizationLevel($this->_cPtr, $aOptLevel);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class StaticContext{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  StaticContext___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  StaticContext___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  StaticContext___get($this->_cPtr, $var);
    return $r;

  }

  public function addColation($aURI) {
    $r =  StaticContext_addColation($this->_cPtr, $aURI);
    return $r;

  }

  public function addNamespace($aPrefix, $aURI) {
    $r =  StaticContext_addNamespace($this->_cPtr, $aPrefix, $aURI);
    return $r;

  }

  public function addReference() {
    $r =  StaticContext_addReference($this->_cPtr);
    return $r;

  }

  public function containsFunction($aFnNameUri, $aFnNameLocal, $arity) {
    $r =  StaticContext_containsFunction($this->_cPtr, $aFnNameUri, $aFnNameLocal, $arity);
    return $r;

  }

  public function createChildContext() {
    $r =  StaticContext_createChildContext($this->_cPtr);
    return is_resource($r) ? new StaticContext($r) : $r;

  }

  public function declareOption($aQName, $aOptionVal) {
    $r =  StaticContext_declareOption($this->_cPtr, $aQName, $aOptionVal);
    return $r;

  }

  public function disableFunction($aQName, $arity) {
    $r =  StaticContext_disableFunction($this->_cPtr, $aQName, $arity);
    return $r;

  }

  public function free() {
    $r =  StaticContext_free($this->_cPtr);
    return $r;

  }

  public function getBaseURI() {
    $r =  StaticContext_getBaseURI($this->_cPtr);
    return $r;

  }

  public function getBoundarySpacePolicy() {
    $r =  StaticContext_getBoundarySpacePolicy($this->_cPtr);
    return $r;

  }

  public function getConstructionMode() {
    $r =  StaticContext_getConstructionMode($this->_cPtr);
    return $r;

  }

  public function getCopyNamespacesMode($aPreserve, $aInherit) {
    $r =  StaticContext_getCopyNamespacesMode($this->_cPtr, $aPreserve, $aInherit);
    return $r;

  }

  public function getDefaultCollation() {
    $r =  StaticContext_getDefaultCollation($this->_cPtr);
    return $r;

  }

  public function getDefaultElementAndTypeNamespace() {
    $r =  StaticContext_getDefaultElementAndTypeNamespace($this->_cPtr);
    return $r;

  }

  public function getDefaultFunctionNamespace() {
    $r =  StaticContext_getDefaultFunctionNamespace($this->_cPtr);
    return $r;

  }

  public function getDefaultOrderForEmptySequences() {
    $r =  StaticContext_getDefaultOrderForEmptySequences($this->_cPtr);
    return $r;

  }

  public function getNamespaceURIByPrefix($aPrefix) {
    $r =  StaticContext_getNamespaceURIByPrefix($this->_cPtr, $aPrefix);
    return $r;

  }

  public function getOption($aQName, $aOptionValue) {
    $r =  StaticContext_getOption($this->_cPtr, $aQName, $aOptionValue);
    return $r;

  }

  public function getOrderingMode() {
    $r =  StaticContext_getOrderingMode($this->_cPtr);
    return $r;

  }

  public function getRefCount() {
    $r =  StaticContext_getRefCount($this->_cPtr);
    return $r;

  }

  public function getRevalidationMode() {
    $r =  StaticContext_getRevalidationMode($this->_cPtr);
    return $r;

  }

  public function getXPath1_0CompatibMode() {
    $r =  StaticContext_getXPath1_0CompatibMode($this->_cPtr);
    return $r;

  }

  public function loadProlog($arg1, $hints) {
    $r =  StaticContext_loadProlog($this->_cPtr, $arg1, $hints);
    return $r;

  }

  public function removeReference() {
    $r =  StaticContext_removeReference($this->_cPtr);
    return $r;

  }

  public function resetTraceStream() {
    $r =  StaticContext_resetTraceStream($this->_cPtr);
    return $r;

  }

  public function setBaseURI($aBaseURI) {
    $r =  StaticContext_setBaseURI($this->_cPtr, $aBaseURI);
    return $r;

  }

  public function setBoundarySpacePolicy($aMode) {
    $r =  StaticContext_setBoundarySpacePolicy($this->_cPtr, $aMode);
    return $r;

  }

  public function setConstructionMode($aMode) {
    $r =  StaticContext_setConstructionMode($this->_cPtr, $aMode);
    return $r;

  }

  public function setCopyNamespacesMode($aPreserve, $aInherit) {
    $r =  StaticContext_setCopyNamespacesMode($this->_cPtr, $aPreserve, $aInherit);
    return $r;

  }

  public function setDefaultCollation($aURI) {
    $r =  StaticContext_setDefaultCollation($this->_cPtr, $aURI);
    return $r;

  }

  public function setDefaultElementAndTypeNamespace($aURI) {
    $r =  StaticContext_setDefaultElementAndTypeNamespace($this->_cPtr, $aURI);
    return $r;

  }

  public function setDefaultFunctionNamespace($aURI) {
    $r =  StaticContext_setDefaultFunctionNamespace($this->_cPtr, $aURI);
    return $r;

  }

  public function setDefaultOrderForEmptySequences($aMode) {
    $r =  StaticContext_setDefaultOrderForEmptySequences($this->_cPtr, $aMode);
    return $r;

  }

  public function setOrderingMode($aMode) {
    $r =  StaticContext_setOrderingMode($this->_cPtr, $aMode);
    return $r;

  }

  public function setRevalidationMode($aMode) {
    $r =  StaticContext_setRevalidationMode($this->_cPtr, $aMode);
    return $r;

  }

  public function setXPath1_0CompatibMode($aMode) {
    $r =  StaticContext_setXPath1_0CompatibMode($this->_cPtr, $aMode);
    return $r;

  }

  public function destroy() {
    $r =  StaticContext_destroy($this->_cPtr);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}

class Zorba{
  public $_cPtr=null;

  public function __set($var, $value) {
    $r =  Zorba___set($this->_cPtr, $var, $value);
    return $r;

  }

  public function __isset($var) {
    $r =  Zorba___isset($this->_cPtr, $var);
    return $r;

  }

  public function __get($var) {
    $r =  Zorba___get($this->_cPtr, $var);
    return $r;

  }

  static  public function getInstance($arg1) {
    $r =  Zorba_getInstance($arg1);
    return is_resource($r) ? new Zorba($r) : $r;

  }

  public function createStaticContext() {
    $r =  Zorba_createStaticContext($this->_cPtr);
    return is_resource($r) ? new StaticContext($r) : $r;

  }

  public function compileQuery($aStr) {
    $r =  Zorba_compileQuery($this->_cPtr, $aStr);
    return is_resource($r) ? new XQuery($r) : $r;

  }

  public function getXmlDataManager() {
    $r =  Zorba_getXmlDataManager($this->_cPtr);
    return is_resource($r) ? new XmlDataManager($r) : $r;

  }

  public function shutdown() {
    $r =  Zorba_shutdown($this->_cPtr);
    return $r;

  }

  public function __construct($ptr) {
  	$this->_cPtr = $ptr;
  }

}
